Subject: Re: [PATCH net-next] sockopt: Make SO_BINDTODEVICE readable

From: Brian Haley <[email-masked]>
Date: Tue, 23 Oct 2012 17:43:23 -0400

On 10/22/2012 05:52 PM, Eric Dumazet wrote:

>>> I meant another cpu can be changing dev->name[] content while the
>>> strcpy() is done, and you get a mangled devname, like "for" or "bao"
>>> instead of "foo" or "bar"
>>
>> Even when holding the rcu_read_lock()?  I'd have to hold the rtnl lock there?
> 
> Yes, rcu_read_lock() only makes sure the device doesnt disappear.
> 
> But its name can be changed.

There's a similar bug in the SIOCGIFNAME/dev_ifname() code too then, but I would
think this rare enough that it doesn't happen in practice.

-Brian